/************************************************************************\
 This demo has a lot of extra fluff designed to show some different ways
 of handling the library from the outside. I tried my best to keep the
 more important things on top.

\************************************************************************/



mob/var		//  Example variables that I'll be modifying.
	strength=10
	defense=10
	agility=10
	dexterity=10
	intelligence=10

obj/equippable
	Equip()
		.=..()
		if(.)
			suffix="Equipped"
			//  Overlays can be added here.
	Unequip()
		.=..()
		if(.)
			suffix=null
			//  Overlays can be removed here.

	var		// I went ahead and declared the modifiers I'll be playing with most.
		strength_mod=0
		defense_mod=0
		agility_mod=0
		dexterity_mod=0
		intelligence_mod=0
			//  Since requirements were an afterthought (thanks to someone special in Chat)
			//  they're not listed here, but they can be declared wherever they're needed.

	head
		equipped_on="head"
		hat
			strength_mod=0
			var/variableThatDoesntExist_mod=2		//  Modifiers that don't have a matching mob variable will send a message to world.log when equipped.
			defense_mod=1
			agility_mod=0
			dexterity_mod=0
			intelligence_mod=0
			var/strength_needed=11		//  11 strength is required to equip the hat.
		beanie
			strength_mod=14
			defense_mod=2
		winged_hat_of_abnormal_speed
			defense_mod=1
			agility_mod=20
	shoulders
		equipped_on="shoulders"
		shoulder_pads
			defense_mod=1
			agility_mod=-1
		NFL_approved_shoulder_pads
			defense_mod=3
			agility_mod=-2
	arms
		equipped_on="arms"
		wrist_bands
			defense_mod=1
		bracers
			defense_mod=2
			dexterity_mod=-2
		sweaty_wrist_bands_of_endurance
			defense_mod=20
	hands
		Equip()		//  Overriding to ask which hand.
			equipped_on=input("Which hand do you want to equip it on?") in list("right hand","left hand")
			.=..()
		leaf
			strength_mod=-10
			var/strength_needed=11
		twig
			strength_mod=-4
		stick
			strength_mod=2
		steel_pipe
			strength_mod=5
			agility_mod=-1
		lead_pipe
			strength_mod=8
			agility_mod=-2
		particle_board
			defense_mod=1
		wooden_buckler
			defense_mod=5
		wooden_shield
			defense_mod=10
		wooden_tower_shield
			defense_mod=15
			agility_mod=-1
	body
		equipped_on="body"
		shirt
			defense_mod=1
		sweater
			defense_mod=2
			agility_mod=-1
		sweater_of_coordination
			defense_mod=2
			agility_mod=-1
			dexterity_mod=20
	legs
		equipped_on="legs"
		pants
			defense_mod=1
		jeans
			defense_mod=2
		pants_of_destruction
			strength_mod=20
			defense_mod=1
	feet
		equipped_on="feet"
		shoes
			defense_mod=1
		boots
			defense_mod=2
			agility_mod=-1
		shoes_of_enlightenment
			defense_mod=1
			intelligence_mod=20


	Click()
		if(src in usr)
			Equip_Unequip()
		else if(loc in oview(1))
			Get()
	New()
		vars["icon"]='equipment.dmi'		//  Setting the icon this way keeps the demo in text mode.
		icon_state=name

	verb/Equip_Unequip()
		set name="Equip/Un-equip"
		set category=null
		set src in usr
		if(usr.equipped[equipped_on]==src)
			Unequip(usr)
			usr<<"<span class=info>You remove <span class=name>[src]</span> from your [equipped_on].</span>"
		else
			var/equipped=Equip(usr)
			if(equipped)
				usr<<"<span class=info>You [equipped==src?"equip":"replace <span class=name>[equipped]</span> for"] <span class=name>[src]</span> on your [equipped_on].</span>"
			else
				usr<<"<span class=info>You do not meet the requirements for <span class=name>[src]</span>.</span>"

	verb/Get()
		set category=null
		set src in oview(1)
		if(src in oview(1))
			src.Move(usr)
	verb/Drop()
		set category=null
		set src in usr
		if(src in usr)
			var/mob/M=loc
			if(istype(M) && M.equipped[equipped_on]==src)
				Unequip(M)
				M<<"<span class=info>You remove <span class=name>[src]</span> from your [equipped_on].</span>"
			src.Move(M.loc)
	verb/Look()
		set category=null
		set src in usr
		var/txt="<html><body bgcolor='#000000' text='#888888'><h2 align=center>[name]</h2><table align='center'>"
		for(var/v in vars)		//  Show requirements first.
			if(findtext(v,"_needed") && vars[v])
				txt+="<tr style=color:red><td>[copytext(v,1,findtext(v,"_needed"))] required</td><td>[vars[v]]</td></tr>"
		for(var/v in vars)
			if(findtext(v,"_mod"))
				txt+="<tr><td>[copytext(v,1,findtext(v,"_mod"))] modifier</td><td>[vars[v]]</td></tr>"
		txt+="</table></body></html>"
		usr<<browse(txt,"window=[name];size=400x250")


mob/var/list/equipped=list(
	"head",
	"shoulders",
	"arms",
	"right hand",
	"left hand",
	"body",
	"legs",
	"feet"
	)

mob
	Stat()
		statpanel("Stats")
		stat("strength",strength)
		stat("defense",defense)
		stat("agility",agility)
		stat("dexterity",dexterity)
		stat("intelligence",intelligence)
		stat("Equipment")
		for(var/v in equipped)
			if(equipped[v])
				var/obj/O=equipped[v]
				stat(v,O.name)
			else
				stat(v,equipped[v])
		statpanel("Inventory",contents)
	Login()
		..()		//  The test items are added here.
		var/list/L=list(typesof(/obj/equippable/head), typesof(/obj/equippable/shoulders), typesof(/obj/equippable/arms), typesof(/obj/equippable/hands), typesof(/obj/equippable/body), typesof(/obj/equippable/legs), typesof(/obj/equippable/feet))
		for(var/x in L)
			var/i=1
			for(var/v in x)
				if(i<length(x))		//  Ditching last entry in typesof list, it is the base type.
					var/obj/O=new v(src)
					src<<"<span class=info>Adding <span class=name>[O.name]</span> to your inventory.</span>"
					sleep()
				i++
		world<<"<span class=worldinfo><span class=name>[src]</span> logs in.</span>"
	Logout()
		world<<"<span class=worldinfo><span class=name>[src]</span> logs out.</span>"
		del src

client
	Command(T)
		if(T=="style")		//  Shows the stylesheet, not sure why. =)
			world<<"<span class=info>[html_encode(file2text(script))]</span>"
		else		//  Simple chat command.
			world<<"<span class=msg><span class=name>[key]</span>: [copytext(html_encode(T),1,750)]</span>"

turf
	text="<font bgcolor='#080'> </font>"