obj
	var/equipped_on

	proc
		Equip(mob/M)
			var/obj/equippable/item=src

			for(var/v in vars)		//  Check requirements.
				if(findtext(v,"_needed"))
					var/variable=copytext(v,1,findtext(v,"_needed"))

					var/current_mod		//  Grab the modifier for any item in the same slot. It will be negated from the requirements check.
					if(M.equipped[equipped_on])
						var/obj/current_item=M.equipped[equipped_on]
						if("[variable]_mod" in current_item.vars)
							current_mod=current_item.vars[variable+"_mod"]

					if(M.vars.Find(variable))
						if(M.vars[variable]-current_mod<vars[v])
							return FALSE		//  Didn't meet the requirements.

					else		//  Let someone know if a variable doesn't fit.
						world.log<<"[src] ([type]) has a requirement named \"[v]\" that doesn't have a matching [M.type] variable \"[variable].\""

			if(M.equipped[equipped_on])		//  Remove anything equipped in the same spot.
				var/obj/equippable/E=M.equipped[equipped_on]
				E.Unequip(M)
				item=E		//  Return old item for prettier player messages.

			M.equipped[equipped_on]=src		//  Equipped.

			for(var/v in vars)		//  Add modifiers.
				if(findtext(v,"_mod"))
					var/variable=copytext(v,1,findtext(v,"_mod"))
					if(M.vars.Find(variable))
						M.vars[variable]+=vars[v]

					else		//  Again, let someone know if a variable doesn't fit.
						world.log<<"[src] ([type]) has a modifier named \"[v]\" that doesn't have a matching [M.type] variable \"[variable].\""
			.=item

		Unequip(mob/M)
			if(M.equipped[equipped_on]==src)
				M.equipped[equipped_on]=null
				for(var/v in vars)
					if(findtext(v,"_mod"))
						var/variable=copytext(v,1,findtext(v,"_mod"))
						if(M.vars.Find(variable))
							M.vars[variable]-=vars[v]
				return TRUE